/**
  * Copyright (c) 2000-2004 Jim Holmstrm. All rights reserved.
  *
  * The author grants you the right to use, modify, and redistribute this
  * software for noncommercial purposes, on the conditions that you:
  * (1) retain the original headers, including the copyright notice and
  * this text, (2) clearly document the difference between any derived
  * software and the original, and (3) acknowledge your use of this
  * software in pertaining publications and reports.  This software
  * is provided "as is", without any warranty of any kind.
  *
  * Author  : Jim Holmstrm
  * E-mail  : jimh@it.uu.se
  *           boll@booru.net
  * Web     : http://user.it.uu.se/~jimh
  *           http://www.booru.net
  *
  */

//-----------------------------------------------------------------------------
// Author: Jim Holmstrm
// Date:   2002-02-13
//-----------------------------------------------------------------------------

#ifndef __EXCEPTION_HH
#define __EXCEPTION_HH

#include <exception>
#include <string>

/**
 * An Exception class that extends std::exception
 */
class Exception : public std::exception
{
protected:
  std::string m_string;

public:
  Exception(std::string const & s) { m_string = s; }
  std::string const & ToString() { return m_string; }
  char const * ToCString() { return m_string.c_str(); }
};

#endif
