/**
  * Copyright (c) 2000-2004 Jim Holmstrm. All rights reserved.
  *
  * The author grants you the right to use, modify, and redistribute this
  * software for noncommercial purposes, on the conditions that you:
  * (1) retain the original headers, including the copyright notice and
  * this text, (2) clearly document the difference between any derived
  * software and the original, and (3) acknowledge your use of this
  * software in pertaining publications and reports.  This software
  * is provided "as is", without any warranty of any kind.
  *
  * Author  : Jim Holmstrm
  * E-mail  : jimh@it.uu.se
  *           boll@booru.net
  * Web     : http://user.it.uu.se/~jimh
  *           http://www.booru.net
  *
  */

//-----------------------------------------------------------------------------
// Author: Jim Holmstrm
// Date:   2002-02-13
//-----------------------------------------------------------------------------

#ifndef __SGNGNODEINSERTER_H
#define __SGNGNODEINSERTER_H

#include <GNGCore/IGNGNodeInserter.hpp>
#include "DefaultNodeInserter.hpp"
class IGNGContainer;
class GNGNode;

/**
 * The default node inserter for the SGNG algorithm, inserts nodes at fixed intervalls.
 *  and adjusts the RBF widths of newly inserted and parents
 */
class SGNGNodeInserter : public DefaultNodeInserter
{
public:
  /**
   * Inserts a new Node, at the apropriate postition.
   * Adjusts the RBF widths.
   * The IGNGContainer component managed nodes and edges
   * and is used to create them.
   */
  virtual void InsertNewNode();

protected:
  virtual double CalculateMeanDistance(GNGNode * n);
};

#endif

