/**
  * Copyright (c) 2000-2004 Jim Holmstrm. All rights reserved.
  *
  * The author grants you the right to use, modify, and redistribute this
  * software for noncommercial purposes, on the conditions that you:
  * (1) retain the original headers, including the copyright notice and
  * this text, (2) clearly document the difference between any derived
  * software and the original, and (3) acknowledge your use of this
  * software in pertaining publications and reports.  This software
  * is provided "as is", without any warranty of any kind.
  *
  * Author  : Jim Holmstrm
  * E-mail  : jimh@it.uu.se
  *           boll@booru.net
  * Web     : http://user.it.uu.se/~jimh
  *           http://www.booru.net
  *
  */

//-----------------------------------------------------------------------------
// Author: Jim Holmstrm
// Date:   2002-02-13
//-----------------------------------------------------------------------------

#ifndef __IGNGNODEMOVEMENT_H
#define __IGNGNODEMOVEMENT_H

#include "../Vector.hpp"

/**
 *  An Interface that defines NodeMover implementations. GNGAlgorithm uses 
 *  NodeMovers when it moves the winner node and when it moves the winner's
 *  neighbors.
 */
class IGNGNodeMovement
{
public:
  /**
   * Creates the new Reference Vector used to move a node.
   * @param i the input Vector, the input signal.
   * @param r the old reference Vector of the node.
   * @param p the movement parameter, how much the new vector will be moved towards the input.
   * @return The new Reference Vector for a node that is to be moved.
   */
  virtual Vector GetNewReferenceVector(Vector const & i, Vector const & r, double p) const = 0;
};

#endif
