/**
  * Copyright (c) 2000-2004 Jim Holmstrm. All rights reserved.
  *
  * The author grants you the right to use, modify, and redistribute this
  * software for noncommercial purposes, on the conditions that you:
  * (1) retain the original headers, including the copyright notice and
  * this text, (2) clearly document the difference between any derived
  * software and the original, and (3) acknowledge your use of this
  * software in pertaining publications and reports.  This software
  * is provided "as is", without any warranty of any kind.
  *
  * Author  : Jim Holmstrm
  * E-mail  : jimh@it.uu.se
  *           boll@booru.net
  * Web     : http://user.it.uu.se/~jimh
  *           http://www.booru.net
  *
  */

#ifndef __IGLINPUTREPRESENTATION_H
#define __IGLINPUTREPRESENTATION_H

/**
 * An Interface that defines an OpenGL representation of an IGNGInputGenereator implementation.
 */
class IGLInputRepresentation
{
public:

  /**
   * This method is called by GNGGLUTRepresentation's Output method.
   * It outputs a representation of the input distribution area.
   */
  virtual void GLOutputDistribution() const = 0;

  /**
   * This method is called by GNGGLUTRepresentation's Output method.
   * It outputs the current signal from the distribution.
   */
  virtual void GLOutputSignal() const = 0; 
  
  /**
  * Called by the GNGGLUT representation to adjust the screen size.
  * @return the max x size of the GLUT representation.
  */
  virtual double GetDisplayXMax() { return 1.0; }
  virtual double GetDisplayYMax() { return 1.0; }
  virtual double GetDisplayXMin() { return -1.0; }
  virtual double GetDisplayYMin() { return -1.0; }
  
};

#endif
