/**
  * Copyright (c) 2000-2004 Jim Holmstrm. All rights reserved.
  *
  * The author grants you the right to use, modify, and redistribute this
  * software for noncommercial purposes, on the conditions that you:
  * (1) retain the original headers, including the copyright notice and
  * this text, (2) clearly document the difference between any derived
  * software and the original, and (3) acknowledge your use of this
  * software in pertaining publications and reports.  This software
  * is provided "as is", without any warranty of any kind.
  *
  * Author  : Jim Holmstrm
  * E-mail  : jimh@it.uu.se
  *           boll@booru.net
  * Web     : http://user.it.uu.se/~jimh
  *           http://www.booru.net
  *
  */


#include "Random.hpp"
#include <cstdlib>
#include <ctime>

bool Random::m_isInitialized = false;

//------------
void Random::InitSeed()
{
  srand((unsigned)time(NULL));
  m_isInitialized = true;	
}

//------------
double Random::Randomize() 
{ 
  if(!m_isInitialized)
    InitSeed();

  return 2.0 * (double)rand() / (double) RAND_MAX - 1.0; 
}


//------------
double Random::RandomizePositive() 
{ 
  if(!m_isInitialized)
    InitSeed();

  return (double)rand() / (double) RAND_MAX ; 
}
