/**
  * Copyright (c) 2000-2004 Jim Holmstrm. All rights reserved.
  *
  * The author grants you the right to use, modify, and redistribute this
  * software for noncommercial purposes, on the conditions that you:
  * (1) retain the original headers, including the copyright notice and
  * this text, (2) clearly document the difference between any derived
  * software and the original, and (3) acknowledge your use of this
  * software in pertaining publications and reports.  This software
  * is provided "as is", without any warranty of any kind.
  *
  * Author  : Jim Holmstrm
  * E-mail  : jimh@it.uu.se
  *           boll@booru.net
  * Web     : http://user.it.uu.se/~jimh
  *           http://www.booru.net
  *
  */

#ifndef __RANDOM_H
#define __RANDOM_H

/**
 * A Randomization class.
 */
class Random
{
public:
	/**
	 * @return a double between -1 and 1
	 */
	static double Randomize();
	
	
	/**
	 * @return a double between 0 and 1
	 */
	static double RandomizePositive();

private:
	/**
	 * Initializes the seed for the random number generator.
	 */
	static void InitSeed();
	static bool m_isInitialized;

};

#endif
